﻿package classes {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import caurina.transitions.Tweener;
	
	public class mc_GomuMushi extends MovieClip {
		
		private var _left_eye:MovieClip;
		private var _right_eye:MovieClip;
		private var _mouth:MovieClip;
		private var _body:MovieClip;
		private var _ke:MovieClip;
		
		private var _angle:Number = 0;
		private var _speed:Number = 0.05;
		
		private var _left_eye_centerX:Number;
		private var _left_eye_centerY:Number;
		private var _right_eye_centerX:Number;
		private var _right_eye_centerY:Number;
		private var _mouth_centerX:Number;
		private var _mouth_centerY:Number;
		
		public function mc_GomuMushi() {
			init();
		}
		
		public function init() {
			_left_eye = left_eye;
			_right_eye = right_eye;
			_mouth = mouth;
			_body = body;
			_ke = ke;
			
			_left_eye_centerX = _left_eye.x;
			_left_eye_centerY = _left_eye.y;
			_right_eye_centerX = _right_eye.x;
			_right_eye_centerY = _right_eye.y;
			_mouth_centerX = _mouth.x;
			_mouth_centerY = _mouth.y;
			
			addEventListener(Event.ENTER_FRAME , onEnterFrame);
			addEventListener(Event.ENTER_FRAME , bodyonEnterFrame);
		}

		
		private function onEnterFrame(e:Event) {
			var offset:Number = 0.5;
			var distLX:Number = offset * (mouseX - _left_eye.x) / 50;
			var distLY:Number = offset * (mouseY - _left_eye.y) / 50;
			var distRX:Number = offset * (mouseX - _right_eye.x) / 50;
			var distRY:Number = offset * (mouseY - _right_eye.y) / 50;
			var distMX:Number = offset*2 * (mouseX - _mouth.x) / 50;
			var distMY:Number = offset * (mouseY - _mouth.y) / 50;
			
			_left_eye.x = _left_eye_centerX + distLX;
			_left_eye.y = _left_eye_centerY + distLY;
			_right_eye.x = _right_eye_centerX + distRX;
			_right_eye.y = _right_eye_centerY + distRY;
			_mouth.x = _mouth_centerX + -distMX;
			_mouth.y = _mouth_centerY + -distMY;
			
		}
		
		private function bodyonEnterFrame(e:Event) {
			var vx:Number = GomuMushi(this.parent.parent).vx;
			_body.rotation = -vx;
		}
		
		public function onDrag() {
			removeEventListener(Event.ENTER_FRAME , onEnterFrame);
			
			for (var i:int = 0; i < 8 ; i++) {
				var mc_ke:MovieClip = new keOne();
				_ke.addChild(mc_ke);
				mc_ke.rotation = Math.random() * 100 -50;
			}
			
			
			Tweener.addTween( _left_eye , {
				x : _left_eye_centerX ,
				y : _left_eye_centerY ,
				scaleX : 3 ,
				scaleY : 3 ,
				time : 1 ,
				transition : "easeoutelastic"
			} );
			
			Tweener.addTween( _right_eye , {
				x : _right_eye_centerX ,
				y : _right_eye_centerY ,
				scaleX : 3 ,
				scaleY : 3 ,
				time : 1 ,
				transition : "easeoutelastic"
			} );
			
			Tweener.addTween( _mouth , {
				x : _mouth_centerX ,
				y : _mouth_centerY ,
				scaleX : 6 ,
				scaleY : 3 ,
				time : 1 ,
				transition : "easeoutelastic"
			} );
			
			Tweener.addTween( _ke , {
				scaleX : 2 ,
				scaleY : 2 ,
				time : 1 ,
				transition : "easeoutelastic"
			} );
			
		}
		
		public function onDrop() {
			addEventListener(Event.ENTER_FRAME , onEnterFrame);
			
			for (var i:int = 0; i < 8; i++) {
				try {
					_ke.removeChild( _ke.getChildAt(1) );
				} catch (e:Error){
					trace("indexが無いだってー。無茶コーディングでつか。汗");
				}
			}
			
			
			Tweener.addTween( _left_eye , {
				scaleX : 1 ,
				scaleY : 1 ,
				time : 1 ,
				transition : "easeoutelastic"
			} );
			
			Tweener.addTween( _right_eye , {
				scaleX : 1 ,
				scaleY : 1 ,
				time : 1 ,
				transition : "easeoutelastic"
			} );
			
			Tweener.addTween( _mouth , {
				scaleX : 1 ,
				scaleY : 1 ,
				time : 1 ,
				transition : "easeoutelastic"
			} );
			
			Tweener.addTween( _ke , {
				scaleX : 1 ,
				scaleY : 1 ,
				time : 1 ,
				transition : "easeoutelastic"
			} );
		}
	}
	
}